<?php
namespace Controleur;

use Gateway\Connection;

Class FrontControler{

    private $listAction;
    
    private string $role = 'visitor';

    private Connection $co;
    
    public function __construct(Connection $co){
        global $twig;

        $this->co=$co;
        
        $this->listAction = ['visitor' => array('accueil','search','quote','login','signin','quiz','valid'),
        'user' => array('quiz','commentary','favorite','logout'),
        'admin' => array('null')];

        $dVueEreur = [];

        $router = new \AltoRouter();

        $router->map('GET', '/', 'VisitorControler');

        /*
        'i'  => '[0-9]++'
        'a'  => '[0-9A-Za-z]++'
        'h'  => '[0-9A-Fa-f]++'
        '*'  => '.+?'
        '**' => '.++'
        ''   => '[^/\.]++'
        */

        $router->map('GET|POST', '/quote/[i:idQuote]?', 'VisitorControler');
        $router->map('GET|POST', '/login', 'VisitorControler');
        $router->map('GET|POST', '/signin', 'VisitorControler');
        $router->map('GET|POST', '/valid', 'VisitorControler');
        $router->map('GET|POST', '/quiz/[i:id]?', 'QuizController');

        $match = $router->match();
        $action = NULL;

        if(!$match){
            $dVueEreur[] = "Requete introuvable";
            $this->vueErreur($dVueEreur);
        }
        else{
            $controller=$match['target'] ?? null;

            $action = explode('/',$_SERVER['PHP_SELF']);
            if(count($action)>2){
                $action=$action[2];
            }
            else{
                $action='accueil';
            }
            //Si existe, on l’appelle
            if(!$this->ifExisteAction($action)){
                $dVueEreur[] = "Action introuvable";
                $this->vueErreur($dVueEreur);
            }

            if(!$this->verifDroit($action) ){
                $action='login';
                $controller='VisitorControler';
            }

            $controller = '\\Controleur\\' . $controller;
            $controller = new $controller($this->co, $action);
            if (is_callable(array($controller, $action))) {
                call_user_func_array(array($controller, $action),
                array($match['params'])); 
            }
    
        }


    }

    private function ifExisteAction(string $action):bool {
        if( in_array($action , $this->listAction['admin']) ||
            in_array($action , $this->listAction['user']) ||
            in_array($action , $this->listAction['visitor']) ) {
                return true;
            }
        
        return false;
    }

    private function verifDroit(string $action):bool {
        if( in_array($action , $this->listAction['admin']) && $this->role == 'admin') return true;
        elseif( in_array($action , $this->listAction['user']) && ($this->role == 'admin' || $this->role == 'user') ) return true;
        elseif(in_array($action , $this->listAction['visitor']) && ($this->role == 'admin'|| $this->role == 'user'|| $this->role == 'visitor')) return true;
        return false;
    }

    private function vueErreur(array $dVueErreur){
        global $vues;
        echo "{$dVueErreur[0]}";
        require_once $vues['erreur'];
    }

}
