<?php

namespace Controleur;

use Entity\QuestionEntity;
use Gateway\Connection;
use Gateway\QuestionGateway;
use Gateway\QuizGateway;
use Gateway\QuizQuestionGateway;
use Model\QuestionModel;
use Model\QuizModel;
use Model\QuizQuestionModel;
use Twig\Environment;
use Twig\Error\LoaderError;
use Twig\Error\RuntimeError;
use Twig\Error\SyntaxError;
use Twig\Loader\FilesystemLoader;

class QuizController
{
    private int $no_question = 0;

    private Connection $co;

    private QuestionGateway $gw;

    private QuestionModel $mdl;


    /**
     * @throws SyntaxError
     * @throws RuntimeError
     * @throws LoaderError
     */
    public function __construct(Connection $co, ?string $action = null)
    {
        $this -> co = $co;
        $this -> gw = new QuestionGateway($this->co);
        $this -> mdl = new QuestionModel($this->gw);

        $loader = new FilesystemLoader('vue/templates');

        $action = $_REQUEST['action'] ?? null;

        $id = (int) explode('/', $_SERVER['REQUEST_URI'])[2] ?? null;

        switch ($action) {
            case 'canswer':

                if ($this->CorrectAnswer())
                    echo "Bonne réponse";
                else echo "Mauvaise réponse";
                $this->no_question ++;
                echo $this->no_question;
                $this->showQuestion($id, $this->no_question);
                break;
            default:
                switch($id)
                {
                    case null:
                        // page erreur
                        break;
                    default:
                        $this->showQuestion($id, $this->no_question);
                        break;
                }
        }

    }

    public function CorrectAnswer() : bool
    {
        $answera = $_POST['answera'] ?? null;
        $answerb = $_POST['answerb'] ?? null;
        $answerc = $_POST['answerc'] ?? null;
        $answerd = $_POST['answerd'] ?? null;

        $id= null;
        $answer = null;

        if ($answera) {
            $answer = explode('-', $answera)[0];
            $id = (int) explode('-', $answera)[1];
        } elseif ($answerb) {
            $answer = explode('-', $answerb)[0];
            $id = (int) explode('-', $answerb)[1];
        } elseif ($answerc) {
            $answer = explode('-', $answerc)[0];
            $id = (int) explode('-', $answerc)[1];
        } elseif ($answerd) {
            $answer = explode('-', $answerd)[0];
            $id = (int) explode('-', $answerd)[1];
        }

        $res = $this->mdl->getQuestion($id);
        return $answer == $res->getCanswer();
    }

    public function GetQuestion(int $id): array
    {
        $gw = new QuizQuestionGateway($this->co);
        $mdl = new QuizQuestionModel($gw);
        return $mdl->getAllQuestionByQuiz($id, $this->co);
    }

    /**
     * @throws RuntimeError
     * @throws SyntaxError
     * @throws LoaderError
     */
    public function showQuestion(int $id, int $no) : void
    {
        global $twig;
        $q = $this->GetQuestion($id);
        $question = $q[$no];

        $idquestion = $question->getIdQuestion();
        echo $twig->render('quiz.html.twig', ['question' => $question,'id'=>$idquestion]);
    }

    public function getNumberOfQuestion() : int
    {
        $gw = new QuizGateway($this->co);
        $mdl = new QuizModel($gw);
        return 0;

    }

}

/*

<php

    foreach ($news as $new)
    {
        <h2 href=<?= $new->getUrl() ?>> <?= $new->getTitle() ?> </h2>
    }

?>


*/